<?php
/**
 * Copyright (с) Cloud Linux GmbH & Cloud Linux Software, Inc 2010-2022 All Rights Reserved
 *
 * Licensed under CLOUD LINUX LICENSE AGREEMENT
 * https://www.cloudlinux.com/legal/
 */

namespace CloudLinux\SmartAdvice\App\Service;

/**
 * Mailer
 */
abstract class Mailer {
	/**
	 * Headers.
	 *
	 * @return string[]
	 */
	public function headers() {
		return array( 'Content-Type: text/html; charset=UTF-8' );
	}

	/**
	 * Can send to WP users.
	 *
	 * @return bool
	 */
	abstract public function availableToWpUsers();

	/**
	 * Can send to Panel users.
	 *
	 * @return bool
	 */
	abstract public function availableToPanelUsers();

	/**
	 * Subject.
	 *
	 * @param string $site_url url.
	 *
	 * @return string
	 */
	abstract public function subject( $site_url );

	/**
	 * Template file.
	 *
	 * @return string
	 */
	abstract public function template();

	/**
	 * Template data.
	 *
	 * @return array
	 */
	abstract public function payload();
}
